<html>
<head>
    <meta charset="UTF-8" />
    <title>Démo</title>
    <link rel="stylesheet" href="inputStyle.css" />
</head>
<body>
    <script type="module">
    import { h, registerElement, registerDatatype, validateDatatype, Datatype } from '../index.js';

    let dt = new Datatype({t:"string"});
    console.log(dt.validate("3")); // -> returns true
    console.log(dt.validate(3));  //-> returns false


    registerElement("button",function(props, options){
        return h({elt:"input", type:"button", on:{click:function(){console.log("click")}}, value:"Click me" })
    });

    document.body.appendChild(h({elt:"div", Text:"Coucou", child:[{elt:"button",style:{fontWeight:"bold"}}, {elt:"button"}]}));

    let v3 = {t:"object", properties:[
        {n:"x", t:"number"},
        {n:"y", t:"number"},
        {n:"z", t:"number"},
    ]}
    validateDatatype(v3, true);
    registerDatatype('vector3', v3);
    validateDatatype({t:"vector3"}, true)

    dt = {t:"object", properties:[
        {n:"name", t:"string"},
        {n:"age", t:"int8", min:6, max:120, step:1},
        {n:"taille", t:"enum", values:["petit","moyen","grand"]},
        {n:"couleur", t:"color3", opt:true},
        {n:"naissance", t:"dateTime"},
        {n:"obj", t:"vector3"},
    ]};
    validateDatatype(dt, true);
    let cdt = new Datatype(dt);
    let buff = cdt.toBinary({name:"toto", age:8, taille:1, naissance:new Date(1991,10,8,3,30), obj:{x:1,y:0,z:0}})
    let o = cdt.fromBinary(buff);

    document.body.appendChild(cdt.getInputUI(o, {onchange:console.warn, oninput:console.log} ));


    let x = {t:"object", properties:[
        {n:"name", t:"shortString"},
        {n:"buffer", t:"int32Array"},
        {n:"array", t:"array", type:{t:"float32"}},
    ]}
    let dtt = new Datatype(x); 
    let a = {name:"test", buffer:new Int32Array([0,1,2,3]), array:[4,5,6] };
    let buffer = dtt.toBinary(a);
    let b = dtt.fromBinary(buffer);
    console.log(b);

    </script>
</body>
</html>